---
image: docker:18-git
services:
  - docker:18-dind

stages:
  - lint
  - build
  - test
  - generate_release
  - release

variables:
  DOCKER_HOST: tcp://docker:2375
  DOCKER_DRIVER: overlay2
  CONTAINER_TEST_IMAGE: $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG
  CONTAINER_RELEASE_IMAGE: $CI_REGISTRY_IMAGE:latest

include:
  - project: dreamer-labs/repoman/gitlab-ci-templates
    file: /.gitlab-ci-commitchecker.yml
    ref: master
  - project: dreamer-labs/repoman/gitlab-ci-templates
    file: /.gitlab-ci-lintdocs.yml
    ref: master
  - project: dreamer-labs/repoman/gitlab-ci-templates
    file: /.gitlab-ci-generate-release.yml
    ref: master

lint:
  image: python:3.7-alpine
  stage: lint
  before_script:
    - pip install tox
  script:
    - tox -e lint
  except:
    variables:
      - $CI_COMMIT_MESSAGE =~ /^chore\(release\)/
  only:
    refs:
      - merge_requests
      - master

build:
  stage: build
  before_script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
  script:
    - docker build --pull -t $CONTAINER_TEST_IMAGE .
    - docker push $CONTAINER_TEST_IMAGE
  only:
    - merge_requests
    - master

release-image:
  stage: release
  before_script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
  script:
    - docker pull $CONTAINER_TEST_IMAGE
    - docker tag $CONTAINER_TEST_IMAGE $CONTAINER_RELEASE_IMAGE
    - docker push $CONTAINER_RELEASE_IMAGE
  only:
    refs:
      - master
    variables:
      - $CI_COMMIT_MESSAGE =~ /^chore\(release\)/
